## doomsday 2.2.2+ds1

=== doomsday/CMakeLists.txt ===
# Doomsday Engine - Main project file
# This CMakeLists builds everything.

cmake_minimum_required (VERSION 3.1)
project (Doomsday)

include (cmake/Config.cmake)

add_subdirectory (sdk)
add_subdirectory (apps)
if (NOT IOS)
    if (DENG_ENABLE_TOOLS)
        add_subdirectory (tools)
    endif ()
    add_subdirectory (tests)
endif ()
add_subdirectory (post)

=== doomsday/apps/libdoomsday/CMakeLists.txt ===
# Doomsday Engine -- libdoomsday

cmake_minimum_required (VERSION 3.1)
project (DENG_LIBDOOMSDAY)
include (../../cmake/Config.cmake)

# Dependencies.
find_package (DengCore)
find_package (DengLegacy)
find_package (DengShell)
find_package (LZSS)
include (ZLIB)

# Definitions.
add_definitions (
    -D__DENG__=1
    -D__LIBDOOMSDAY__=1
)

# Set up the API.
include_directories (${DENG_API_DIR})
configure_file (
    ${DENG_API_DIR}/dd_version.h.in
    ${DENG_API_DIR}/dd_version.h
)

# Source and header files.
file (GLOB_RECURSE HEADERS include/doomsday/*)
file (GLOB SOURCES src/c_wrapper/*.cpp)

deng_merge_sources (libdoomsday src/*.cpp)
deng_merge_sources (defs        src/defs/*.cpp)
deng_merge_sources (console     src/console/*.cpp)
deng_merge_sources (filesys     src/filesys/*.cpp)
deng_merge_sources (resource    src/resource/*.cpp)
deng_merge_sources (world       src/world/*.cpp)

deng_add_package (net.dengine.base)

deng_add_library (libdoomsday ${SOURCES} ${HEADERS})
relaxed_warnings (libdoomsday)
target_link_libraries (libdoomsday
    PUBLIC Deng::libcore Deng::liblegacy Deng::libshell
    PRIVATE lzss
)
target_include_directories (libdoomsday PRIVATE ${ZLIB_INCLUDE_DIR})

if (DENG_ENABLE_SDK)
    install (DIRECTORY include/doomsday
        DESTINATION include
        COMPONENT sdk
    )
endif ()
deng_deploy_library (libdoomsday DengDoomsday)

=== doomsday/apps/plugins/CMakeLists.txt ===
# The Doomsday Engine Project
# Copyright (c) 2015-2017 Jaakko Keränen <jaakko.keranen@iki.fi>

cmake_minimum_required (VERSION 3.1)
project (Plugins)
include (../../cmake/Config.cmake)

# Libraries -----------------------------------------------------------------------------

add_subdirectory (libgamefw)

# Importers -----------------------------------------------------------------------------

add_subdirectory (importdeh)
add_subdirectory (importidtech1)
add_subdirectory (importudmf)
if (NOT IOS)
    add_subdirectory (importsave)
endif ()

# Games ---------------------------------------------------------------------------------

add_subdirectory (doom)
add_subdirectory (heretic)
add_subdirectory (hexen)
add_subdirectory (doom64)

# Audio ---------------------------------------------------------------------------------

add_subdirectory (fmod)
if (NOT TARGET audio_fmod)
    add_subdirectory (openal)
endif ()
if (NOT IOS)
    add_subdirectory (fluidsynth)
endif ()
if (WIN32)
    add_subdirectory (directsound)
    add_subdirectory (winmm)
endif ()

# Other ---------------------------------------------------------------------------------

if (DENG_DEVELOPER AND NOT IOS)
    add_subdirectory (example)
endif ()

=== doomsday/apps/server/CMakeLists.txt ===
# The Doomsday Engine Project -- Server
# Copyright (c) 2012-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
# Copyright (c) 2012-2015 Daniel Swanson <danij@dengine.net>

cmake_minimum_required (VERSION 3.1)
project (DENG_SERVER)
include (../../cmake/Config.cmake)

# Dependencies.
find_package (DengCore)
find_package (DengLegacy)
find_package (DengShell)
find_package (DengDoomsday)
find_package (Amethyst QUIET)

include_directories (include ../client/include ${DENG_API_DIR})

add_definitions (-D__DOOMSDAY__=1 -D__SERVER__=1)

file (GLOB API_HEADERS ../api/*.h)
file (GLOB_RECURSE HEADERS include/*)
file (GLOB SOURCES src/*.cpp)

deng_merge_sources (server src/server/*.cpp)

# TODO: Get rid of these, shared code should be in libdoomsday.
set (src ../client)
set (SHARED_WITH_CLIENT
    ${src}/include/audio/audiosystem.h
    ${src}/include/audio/s_cache.h
    ${src}/include/audio/s_environ.h
    ${src}/include/con_config.h
    ${src}/include/dd_def.h
    ${src}/include/dd_loop.h
    ${src}/include/dd_main.h
    ${src}/include/dd_pinit.h
    ${src}/include/def_main.h
    ${src}/include/de_base.h
    ${src}/include/de_platform.h
    ${src}/include/edit_map.h
    ${src}/include/misc/color.h
    ${src}/include/misc/face.h
    ${src}/include/misc/hedge.h
    ${src}/include/misc/mesh.h
    ${src}/include/misc/r_util.h
    ${src}/include/misc/tab_anorms.h
    ${src}/include/m_profiler.h
    ${src}/include/network/masterserver.h
    ${src}/include/network/monitor.h
    ${src}/include/network/net_buf.h
    ${src}/include/network/net_event.h
    ${src}/include/network/net_main.h
    ${src}/include/network/net_msg.h
    ${src}/include/sys_system.h
    ${src}/include/ui/busyvisual.h
    ${src}/include/ui/infine/finale.h
    ${src}/include/ui/infine/finaleanimwidget.h
    ${src}/include/ui/infine/finaleinterpreter.h
    ${src}/include/ui/infine/finalepagewidget.h
    ${src}/include/ui/infine/finaletextwidget.h
    ${src}/include/ui/infine/finalewidget.h
    ${src}/include/world/bindings_world.h
    ${src}/include/world/blockmap.h
    ${src}/include/world/bsp/convexsubspaceproxy.h
    ${src}/include/world/bsp/edgetip.h
    ${src}/include/world/bsp/hplane.h
    ${src}/include/world/bsp/linesegment.h
    ${src}/include/world/bsp/partitioner.h
    ${src}/include/world/bsp/partitionevaluator.h
    ${src}/include/world/bsp/superblockmap.h
    ${src}/include/world/bspleaf.h
    ${src}/include/world/clientserverworld.h
    ${src}/include/world/convexsubspace.h
    ${src}/include/world/impulseaccumulator.h
    ${src}/include/world/interceptor.h
    ${src}/include/world/line.h
    ${src}/include/world/lineblockmap.h
    ${src}/include/world/lineowner.h
    ${src}/include/world/linesighttest.h
    ${src}/include/world/map.h
    ${src}/include/world/maputil.h
    ${src}/include/world/plane.h
    ${src}/include/world/polyobj.h
    ${src}/include/world/polyobjdata.h
    ${src}/include/world/p_object.h
    ${src}/include/world/p_players.h
    ${src}/include/world/p_ticker.h
    ${src}/include/world/reject.h
    ${src}/include/world/sector.h
    ${src}/include/world/sky.h
    ${src}/include/world/surface.h
    ${src}/include/world/thinkers.h
    ${src}/include/world/vertex.h

    ${src}/src/api_console.cpp
    ${src}/src/api_filesys.cpp
    ${src}/src/api_map.cpp
    ${src}/src/api_mapedit.cpp
    ${src}/src/api_uri.cpp
    ${src}/src/con_config.cpp
    ${src}/src/dd_loop.cpp
    ${src}/src/dd_main.cpp
    ${src}/src/dd_pinit.cpp
    ${src}/src/def_main.cpp
    ${src}/src/sys_system.cpp
)

deng_merge_sources (audio_base    ${src}/src/audio/base/*.cpp)
deng_merge_sources (infine        ${src}/src/ui/infine/*.cpp)
deng_merge_sources (misc          ${src}/src/misc/*.cpp)
deng_merge_sources (net_base      ${src}/src/network/base/*.cpp)
deng_merge_sources (resource_base ${src}/src/resource/base/*.cpp)
deng_merge_sources (world_base    ${src}/src/world/base/*.cpp)
deng_merge_sources (world_bsp     ${src}/src/world/bsp/*.cpp)

if (WIN32)
    include_directories (../client/include/windows)
    list (APPEND SHARED_WITH_CLIENT ${src}/src/windows/dd_winit.cpp)
endif ()

if (UNIX)
    include_directories (../client/include/unix)
    list (APPEND SHARED_WITH_CLIENT ${src}/src/unix/dd_uinit.cpp)

    if (AMETHYST_FOUND)
        set (MAN_PAGE ${CMAKE_CURRENT_BINARY_DIR}/doomsday-server.6)
        list (APPEND SOURCES ${MAN_PAGE})
        deng_add_amedoc (MAN ${MAN_PAGE} ${DENG_SOURCE_DIR}/doc/server server.ame)
    endif ()
endif ()

add_executable (server ${SOURCES} ${HEADERS} ${API_HEADERS} ${SHARED_WITH_CLIENT})
deng_target_defaults (server)
set_target_properties (server PROPERTIES
    OUTPUT_NAME "doomsday-server"
    FOLDER Apps
)

# There's some old code here so relax the warnings a bit.
relaxed_warnings (server)

target_link_libraries (server
    Deng::libcore
    Deng::liblegacy
    Deng::libshell
    Deng::libdoomsday
)

# Server is installed as part of the "client" component instead of the
# default "tools".
deng_install_tool (server client)

deng_cotire (server include/precompiled.h)

=== doomsday/sdk/libcore/CMakeLists.txt ===
# Doomsday Engine -- libcore

cmake_minimum_required (VERSION 3.1)
project (DENG_LIBCORE)
include (../../cmake/Config.cmake)

# Dependencies.
include (ZLIB)
find_package (Git QUIET)

# Definitions.
add_definitions (
    -D__DENG2__=1
    -DLIBDENG2_MAJOR_VERSION=${DENG_VERSION_MAJOR}
    -DLIBDENG2_MINOR_VERSION=${DENG_VERSION_MINOR}
    -DLIBDENG2_PATCHLEVEL=${DENG_VERSION_PATCH}
    -DLIBDENG2_RELEASE_LABEL="${DENG_RELEASE_TYPE}"
    -DLIBDENG2_VERSION="${DENG_VERSION}"
)
if (DEFINED DENG_BUILD)
    add_definitions (-DLIBDENG2_BUILD_TEXT="${DENG_BUILD}")
endif ()
if (GIT_FOUND)
    execute_process (
        COMMAND ${GIT_EXECUTABLE} describe --tags --always --long
        OUTPUT_VARIABLE DENG_GIT_DESCRIPTION
        ERROR_QUIET
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    if (DENG_GIT_DESCRIPTION)
        message (STATUS "Revision: ${DENG_GIT_DESCRIPTION}")
        add_definitions (-DLIBDENG2_GIT_DESCRIPTION="${DENG_GIT_DESCRIPTION}")
    endif ()
endif ()

# Source and header files.
file (GLOB_RECURSE HEADERS include/de/[a-zA-Z]*)
file (GLOB SOURCES src/*.cpp src/*.h src/core/*.h)

deng_merge_sources (concurrency    src/concurrency/*.cpp)
deng_merge_sources (core           src/core/*.cpp)
deng_merge_sources (data           src/data/*.cpp)
deng_merge_sources (filesys        src/filesys/*.cpp)
deng_merge_sources (filesys_remote src/filesys/remote/*.cpp)
deng_merge_sources (net            src/net/*.cpp)
deng_merge_sources (scriptsys      src/scriptsys/*.cpp)
deng_merge_sources (widgets        src/widgets/*.cpp)

if (WIN32)
    # Update the resource file.
    set (DENG_LIBCORE_VERSION_WINDOWS ${DENG_VERSION_WINDOWS})
    configure_file (res/win32/core.rc.in core.rc)
    list (APPEND SOURCES ${CMAKE_CURRENT_BINARY_DIR}/core.rc)
    include_directories (res/win32)
endif ()

deng_add_package (net.dengine.stdlib)

deng_add_library (libcore ${SOURCES} ${HEADERS})
target_include_directories (libcore PRIVATE ${ZLIB_INCLUDE_DIR})
deng_target_link_qt (libcore PUBLIC Core Network)
target_link_libraries (libcore PUBLIC ${ZLIB_LIBRARIES})
if (UNIX AND NOT APPLE)
    if (DENG_BASE_DIR)
        set (baseDir "${DENG_BASE_DIR}")
    else ()
        set (baseDir "${CMAKE_INSTALL_PREFIX}/${DENG_INSTALL_DATA_DIR}")
    endif ()
    if (DENG_LIBRARY_DIR)
        set (libDir "${DENG_LIBRARY_DIR}")
    else ()
        set (libDir "${CMAKE_INSTALL_PREFIX}/${DENG_INSTALL_PLUGIN_DIR}")
    endif ()
    target_compile_definitions (libcore PUBLIC
        -DDENG_BASE_DIR="${baseDir}"
        -DDENG_LIBRARY_DIR="${libDir}"
    )
endif ()

deng_deploy_library (libcore DengCore)

deng_cotire (libcore src/precompiled.h)

=== doomsday/sdk/libgui/CMakeLists.txt ===
# Doomsday Engine -- libgui

cmake_minimum_required (VERSION 3.1)
project (DENG_LIBGUI)

option (DENG_ASSIMP_EMBEDDED "Use the Assimp from 'external/assimp' instead of system libraries" YES)

set (CMAKE_INSTALL_DEFAULT_COMPONENT_NAME)

#----------------------------------------------------------------------------------------
# Configure Assimp first as a static library. Doomsday's Config is not
# included yet so that Assimp's build products are not included in
# the client component.
if (DENG_ASSIMP_EMBEDDED)
    set (ASSIMP_BUILD_ASSIMP_TOOLS OFF CACHE BOOL "Assimp: Build tools" FORCE)
    set (ASSIMP_BUILD_TESTS OFF CACHE BOOL "Assimp: Build tests" FORCE)
    set (BUILD_SHARED_LIBS OFF CACHE BOOL "Assimp: Shared library" FORCE)
    if (APPLE OR WIN32)
        set (ASSIMP_LIB_INSTALL_DIR ${DENG_INSTALL_LIB_DIR}
            CACHE PATH "libassimp install directory" FORCE
        )
    else ()
        set (ASSIMP_LIB_INSTALL_DIR ${DENG_INSTALL_PLUGIN_DIR}
            CACHE PATH "libassimp install directory" FORCE
        )
    endif ()

    # Enable only the relevant Assimp model importers.
    set (_allAssimpFormats
        3DS AC ASE ASSBIN ASSXML B3D BVH COLLADA DXF CSM HMP IRR LWO LWS MD2 MD3 MD5
        MDC MDL NFF NDO OFF OBJ OGRE OPENGEX PLY MS3D COB BLEND IFC XGL FBX Q3D Q3BSP RAW SMD
        STL TERRAGEN 3D X)
    set (_enabledAssimpFormats 3DS COLLADA MD2 MD3 MD5 MDL OBJ BLEND FBX IRR)
    foreach (_fmt ${_allAssimpFormats})
        list (FIND _enabledAssimpFormats ${_fmt} _pos)
        if (_pos GREATER -1)
            set (_enabled YES)
        else ()
            set (_enabled NO)
        endif ()
        set (ASSIMP_BUILD_${_fmt}_IMPORTER ${_enabled} CACHE BOOL "Assimp: Enable ${_fmt} importer")
    endforeach (_fmt)

    set (CMAKE_AUTOMOC OFF)
    set (oldCFlags ${CMAKE_C_FLAGS})
    if (NOT MSVC)
        set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-incompatible-pointer-types")
    endif ()
    if (CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-address-of-packed-member")
    endif ()
    add_subdirectory (../../external/assimp assimp)
    set_property (TARGET assimp PROPERTY FOLDER Libraries)
    set (CMAKE_C_FLAGS ${oldCFlags})
    add_definitions (-DDENG_HAVE_CUSTOMIZED_ASSIMP=1)
endif ()
#----------------------------------------------------------------------------------------

# Apply Doomsday's configuration.
include (../../cmake/Config.cmake)

# libgui uses Qt 5.4 OpenGL APIs.
qmake_query (QT_VERSION "QT_VERSION")
if (QT_VERSION VERSION_LESS 5.4)
    message (FATAL_ERROR "libgui requires Qt 5.4 or newer! You can disable all GUI features with DENG_ENABLE_GUI=OFF.")
endif ()

if (APPLE)
    # Don't change display modes on macOS/iOS. We'll instead resize the
    # frame buffer and scale up.
    set (DENG_ENABLE_DISPLAYMODE_DEFAULT OFF)
else ()
    set (DENG_ENABLE_DISPLAYMODE_DEFAULT ON)
endif ()
option (DENG_ENABLE_DISPLAYMODE "Enable/disable changing the display mode"
    ${DENG_ENABLE_DISPLAYMODE_DEFAULT}
)

# OpenGL API selection.
set (DENG_OPENGL_API "3.3" CACHE STRING "OpenGL API selection (3.3, GLES3, GLES2)")

if (IOS)
    set (DENG_OPENGL_API "GLES3" CACHE STRING "OpenGL API selection" FORCE)
endif ()

# Dependencies.
find_package (DengCore)
find_package (Assimp REQUIRED)
if (DENG_X11)
    find_package (X11 REQUIRED)
endif ()

deng_add_package (net.dengine.stdlib.gui)

# Definitions.
add_definitions (-D__LIBGUI__=1)
if (DENG_OPENGL_API STREQUAL "3.3")
    add_definitions (-DDENG_OPENGL=330)
    message (STATUS "Using OpenGL 3.3")
elseif (DENG_OPENGL_API STREQUAL "GLES3")
    add_definitions (-DDENG_OPENGL_ES=30)
    message (STATUS "Using OpenGL ES 3.0")
elseif (DENG_OPENGL_API STREQUAL "GLES2")
    add_definitions (-DDENG_OPENGL_ES=20)
    message (STATUS "Using OpenGL ES 2.0")
else ()
    message (FATAL_ERROR "Invalid value for OpenGL API: ${DENG_OPENGL_API}")
endif ()

# Source and header files.
file (GLOB_RECURSE HEADERS include/de/*)
file (GLOB SOURCES src/*.cpp src/*.h src/input/*.c)

deng_merge_sources (audio    src/audio/*.cpp)
deng_merge_sources (graphics src/graphics/*.cpp)
deng_merge_sources (input    src/input/*.cpp)
deng_merge_sources (text     src/text/*.cpp)

# Choose which DisplayMode sources to use.
list_remove_matches (SOURCES ".*/displaymode_.*")
if (NOT DENG_ENABLE_DISPLAYMODE)
    list (APPEND SOURCES src/displaymode_dummy.cpp)
else ()
    list (APPEND SOURCES src/displaymode_${DENG_PLATFORM_SUFFIX})
endif ()

# Ignore mobile-only sources.
list_remove_matches (HEADERS ".*_qml.*")
list_remove_matches (SOURCES ".*_qml.*")

deng_add_library (libgui ${SOURCES} ${HEADERS})

target_link_libraries (libgui
    PUBLIC Deng::libcore
    PRIVATE libassimp
)
deng_target_link_qt (libgui PUBLIC Gui OpenGLExtensions Widgets)

if (UNIX AND NOT APPLE)
    # The assimp target may be linked to some system libraries that
    # must be linked publicly (rather than privately like is the
    # done for libassimp).
    get_property (assimpLibs TARGET libassimp PROPERTY INTERFACE_LINK_LIBRARIES)
    target_link_libraries (libgui PUBLIC ${assimpLibs})
endif ()

if (IOS)
    link_framework (libgui PRIVATE OpenGLES)
elseif (APPLE)
    link_framework (libgui PRIVATE Cocoa)
    link_framework (libgui PRIVATE OpenGL)
endif ()

if (DENG_X11)
    target_include_directories (libgui PRIVATE ${X11_INCLUDE_DIR})
    target_link_libraries (libgui PRIVATE ${X11_LIBRARIES})
    deng_target_link_qt (libgui PRIVATE X11Extras)
    if (DENG_ENABLE_DISPLAYMODE)
        if (NOT X11_Xrandr_FOUND)
            message (FATAL_ERROR "DisplayMode requires X11 Xrandr extension (enable/disable with DENG_ENABLE_DISPLAYMODE)")
        endif ()
        if (NOT X11_xf86vmode_FOUND)
            message (FATAL_ERROR "DisplayMode requires X11 xf86vmode extension (enable/disable with DENG_ENABLE_DISPLAYMODE)")
        endif ()
        target_include_directories (libgui PRIVATE
            ${X11_Xrandr_INCLUDE_PATH}
            ${X11_xf86vmode_INCLUDE_PATH}
        )
        target_link_libraries (libgui PRIVATE
            ${X11_Xrandr_LIB}
            ${X11_Xxf86vm_LIB}
        )
    endif ()
endif ()

deng_deploy_library (libgui DengGui)

# If Assimp is part of the build, ensure that it gets compiled before libgui.
if (TARGET assimp)
    add_dependencies (libgui assimp)
    if (MSVC)
        target_link_libraries (libgui PRIVATE zlibstatic)   # from assimp project
    endif ()
endif ()

deng_cotire (libgui src/precompiled.h)

=== doomsday/sdk/liblegacy/CMakeLists.txt ===
# Doomsday Engine -- liblegacy

cmake_minimum_required (VERSION 3.1)
project (DENG_LIBLEGACY)
include (../../cmake/Config.cmake)

# Dependencies.
find_package (DengCore)

# Options.
option (DENG_LIBLEGACY_WRITER_TYPE_CHECK
    "Type-check Writer1/Reader1 behavior (incompatible with no type checking)"
    OFF
)
if (DENG_LIBLEGACY_WRITER_TYPE_CHECK)
    add_definitions (-DDENG_WRITER_TYPECHECK=1)
endif ()

# Definitions.
add_definitions (-D__DENG__=1 -D__DOOMSDAY__=1)
if (DEFINED DENG_BUILD)
    add_definitions (-DDOOMSDAY_BUILD_TEXT="${DENG_BUILD}")
endif ()

# Source and header files.
file (GLOB_RECURSE HEADERS include/de/*)
file (GLOB_RECURSE SOURCES src/*.cpp src/*.c)
#file (GLOB_RECURSE C_SOURCES src/*.c)

include_directories (include include/de)

deng_add_library (liblegacy ${SOURCES} ${HEADERS})
target_link_libraries (liblegacy PUBLIC Deng::libcore)
if (WIN32)
    target_link_libraries (liblegacy PRIVATE winmm)
endif ()

deng_deploy_library (liblegacy DengLegacy)

=== doomsday/tests/test_appfw/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1)
project (DENG_TEST_APPFW)
include (../TestConfig.cmake)

find_package (Qt5 COMPONENTS Gui Widgets)
find_package (DengAppfw)

deng_add_package (net.dengine.test.appfw)

file (GLOB SOURCES src/*.cpp src/*.h)
deng_add_application (test_appfw ${SOURCES})

target_link_libraries (test_appfw Deng::libappfw)

if (APPLE)
    set_property (TARGET test_appfw PROPERTY OUTPUT_NAME test_appfw)
    deng_install_bundle_deps (test_appfw
        Deng::libcore Deng::libgui Deng::libappfw Deng::libshell
    )
    deng_install_deployqt (test_appfw)
endif ()

=== doomsday/tests/test_archive/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1)
project (DENG_TEST_ARCHIVE)
include (../TestConfig.cmake)

deng_test (test_archive main.cpp)

install (FILES test.zip hello.txt DESTINATION ${DENG_INSTALL_DATA_DIR})

=== doomsday/tests/test_bitfield/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1)
project (DENG_TEST_BITFIELD)
include (../TestConfig.cmake)

deng_test (test_bitfield main.cpp)

=== doomsday/tests/test_info/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1)
project (DENG_TEST_INFO)
include (../TestConfig.cmake)

deng_test (test_info main.cpp)

install (FILES test_info.dei DESTINATION ${DENG_INSTALL_DATA_DIR})

=== doomsday/tests/test_script/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1)
project (DENG_TEST_SCRIPT)
include (../TestConfig.cmake)

deng_test (test_script main.cpp)

install (FILES kitchen_sink.ds sections.ds DESTINATION ${DENG_INSTALL_DATA_DIR})

=== debian/changelog ===
doomsday (2.2.2+ds1-1~exp2) experimental; urgency=medium

  * Team upload.
  * debian/control:
    + Replace build-dependency of libqt5opengl5-dev with
      libqt5opengl5-desktop-dev. This game is know to be requiring
      desktop OpenGL support. (Previously explicitly excluded armel
      and armhf in the architecture section)
    + Use "Rules-Require-Root: no".
    + Mark package doomsday-data as Multi-Arch: foreign.
  * debian/copyright: Fix file matching issues (lintian info).
  * debian/doomsday.links: Dropped for now since we are not shipping
    doomsday-compat script.

 -- Boyuan Yang <byang@debian.org>  Fri, 14 Feb 2020 23:00:03 -0500

doomsday (2.2.2+ds1-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release. (Closes: #884608)
    + WARNING: This release (2.2.2+ds1-1~exp1) is an experimental Debian
      package that may break. USE IT AT YOUR OWN RISK!
      If you found any bug with packaged doomsday 2.x, please report it!
    + TODO: Strip out fonts in Files-Exluded list.
    + TODO: Incorporate with the alternatives system.
    + TODO: Move the executables back to /usr/games/.
    + Migrated to Qt5. (Closes: #874870)
    + Migrated to Python3. (Closes: #936437)
  * debian/control:
    + Bump debhelper compat to v12.
    + Bump Standards-Version to 4.5.0.
    + Update build-dependencies and switch to a CMake-based buildsystem.
    + Update Vcs-* fields to use git packaging repo under Salsa games-team.
    + Update homepage field to use secure URI.
  * debian/patches-old: Moved away for a patch-free version.
  * debian/patches:
    + 0001: Add new patch to disable RPATH completely.
    + 0002: Add new patch to let .desktop files use /usr/games/ path.
  * debian/doomsday.install:
    + Do not install a compat script.
  * debian/doomsday-server.install: Install the doomsday-shell and
    doomsday-shell-text binaries. (Closes: #864250)
  * debian/doomsday.desktop: Dropped in favor of upstream desktop file.
  * debian/doomsday.menu: Dropped per tech-ctte's decision.
  * debian/doomsday.xpm: Dropped in favor of upstream-provided icon.
  * debian/upstream/metadata: Add information about Repository and
    Repository-Browse.
  * debian/clean: Also clean doomsday/apps/api/dd_version.h.
  * debian/doomsday.manpages: Update man page installation path.

 -- Boyuan Yang <byang@debian.org>  Fri, 14 Feb 2020 17:39:12 -0500

=== debian/control ===
Source: doomsday
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Michael Gilbert <mgilbert@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 12),
 python3:any,
 qtbase5-dev,
 zlib1g-dev,
 libassimp-dev,
 libfluidsynth-dev,
 libncurses-dev,
 libsdl2-mixer-dev,
 libx11-dev,
 libxrandr-dev,
 libxxf86vm-dev,
 libqt5opengl5-desktop-dev,
 libqt5x11extras5-dev,
 libgl1-mesa-dev | libgl-dev,
 libglu1-mesa-dev | libglu-dev,
 libminizip-dev,
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://www.dengine.net
Vcs-Git: https://salsa.debian.org/games-team/doomsday.git
Vcs-Browser: https://salsa.debian.org/games-team/doomsday

Package: doomsday
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 doomsday-data (>= ${source:Version}), doomsday-data (<< ${source:Version}.1~),
 doomsday-common (>= ${source:Version}), doomsday-common (<< ${source:Version}.1~),
Recommends:
 fluid-soundfont-gm,
Provides:
 boom-engine,
 doom-engine,
 heretic-engine,
 hexen-engine,
Description: enhanced version of the legendary DOOM game
 The purpose of the Doomsday Engine project is to create versions of DOOM,
 Heretic and Hexen that feel the same as the original games but are implemented
 using modern techniques such as 3D graphics and client/server networking. A
 lot of emphasis is placed on good-looking graphics.
 .
 Doomsday Engine (or deng for short) requires an IWAD to play. You can install
 your commercial IWADs using game-data-packager.

Package: doomsday-server
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 doomsday-data (>= ${source:Version}), doomsday-data (<< ${source:Version}.1~),
 doomsday-common (>= ${source:Version}), doomsday-common (<< ${source:Version}.1~),
Replaces:
 doomsday (<= 1.14.5-2),
Breaks:
 doomsday (<= 1.14.5-2),
Description: enhanced version of the legendary DOOM game - server
 The purpose of the Doomsday Engine project is to create versions of DOOM,
 Heretic and Hexen that feel the same as the original games but are implemented
 using modern techniques such as 3D graphics and client/server networking. A
 lot of emphasis is placed on good-looking graphics.
 .
 This package contains the dedicated server.

Package: doomsday-common
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Replaces:
 doomsday (<= 1.14.5-2),
Breaks:
 doomsday (<= 1.14.5-2),
Description: enhanced version of the legendary DOOM game - common files
 The purpose of the Doomsday Engine project is to create versions of DOOM,
 Heretic and Hexen that feel the same as the original games but are implemented
 using modern techniques such as 3D graphics and client/server networking. A
 lot of emphasis is placed on good-looking graphics.
 .
 This package includes files common to both server and client packages.

Package: doomsday-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 freedoom | game-data-packager | boom-wad | doom-wad | heretic-wad | hexen-wad,
Replaces:
 doomsday (<= 1.14.5-2),
Breaks:
 doomsday (<= 1.14.5-2),
Description: enhanced version of the legendary DOOM game - data files
 The purpose of the Doomsday Engine project is to create versions of DOOM,
 Heretic and Hexen that feel the same as the original games but are implemented
 using modern techniques such as 3D graphics and client/server networking. A
 lot of emphasis is placed on good-looking graphics.
 .
 This package includes architecture-independent data files.

## doomsday 2.3.1%2Bds1

=== doomsday/post/CMakeLists.txt ===
include (../cmake/Config.cmake)

if (APPLE)
    # Code-sign and notarize the application bundles.
    if (TARGET client)
        deng_codesign (client)
    endif ()
    if (TARGET shell)
        deng_codesign (shell)
    endif ()
endif ()

=== doomsday/tests/test_record/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1)
project (DENG_TEST_RECORD)
include (../TestConfig.cmake)

deng_test (test_record main.cpp)

=== debian/changelog ===
doomsday (2.3.1+ds1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Workaround FTBFS with CMake 4. (Closes: #1112854)
  * Add workaround from Bernhard Übelacker for running
    under Wayland. (Closes: #1113738)

 -- Adrian Bunk <bunk@debian.org>  Thu, 30 Oct 2025 19:32:32 +0200

doomsday (2.3.1+ds1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump Standards-Version to 4.6.0.
  * debian/*.lintian-overrides: Remove unknown tag
    no-upstream-changelog.

 -- Boyuan Yang <byang@debian.org>  Tue, 07 Sep 2021 17:23:34 -0400

doomsday (2.2.2+ds1-1) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * debian/doomsday-compat: Add back the compatibility layer.
  * debian/patches-old: Drop no-libexample.patch, no longer
    needed.
  * debian/control: Update Vcs-* field to use correct one.

 -- Boyuan Yang <byang@debian.org>  Mon, 02 Mar 2020 15:54:49 -0500

## doomsday 2.3.1+ds1

=== CMakeLists.txt ===
# Doomsday Engine
# Top-level CMakeLists

cmake_minimum_required (VERSION 3.1)
project (Doomsday)
add_subdirectory (doomsday)

=== doomsday/apps/CMakeLists.txt ===
# Doomsday Engine - Applications

cmake_minimum_required (VERSION 3.1)
project (Apps)
include (../cmake/Config.cmake)

add_subdirectory (libdoomsday)
add_subdirectory (plugins)
if (DENG_ENABLE_SERVER AND NOT IOS)
    add_subdirectory (server)
endif ()
if (DENG_ENABLE_GUI)
    add_subdirectory (client)
endif ()

=== doomsday/sdk/CMakeLists.txt ===
# Doomsday SDK 

cmake_minimum_required (VERSION 3.1)
project (SDK)
include (../cmake/Config.cmake)

add_subdirectory (libcore)
add_subdirectory (libshell)
add_subdirectory (liblegacy)
if (DENG_ENABLE_GUI)
    add_subdirectory (libgui)
    add_subdirectory (libappfw)
endif ()

=== doomsday/tests/CMakeLists.txt ===
# The Doomsday Engine Project -- Test Suite
# Copyright (c) 2015-2017 Jaakko Keränen <jaakko.keranen@iki.fi>

cmake_minimum_required (VERSION 3.1)
project (Tests)
include (../cmake/Config.cmake)

option (DENG_ENABLE_TESTS "Enable/disable the test suite" OFF)

if (DENG_ENABLE_TESTS)
    add_subdirectory (test_archive)
    add_subdirectory (test_bitfield)
    add_subdirectory (test_commandline)
    add_subdirectory (test_info)
    add_subdirectory (test_log)
    add_subdirectory (test_pointerset)
    add_subdirectory (test_record)
    add_subdirectory (test_script)
    add_subdirectory (test_string)
    add_subdirectory (test_stringpool)
    add_subdirectory (test_vectors)
    if (DENG_ENABLE_GUI)
        add_subdirectory (test_appfw)
        add_subdirectory (test_glsandbox)
    endif ()
endif ()

=== doomsday/tools/CMakeLists.txt ===
# Doomsday Engine - Tools

cmake_minimum_required (VERSION 3.1)
project (Tools)
include (../cmake/Config.cmake)

# Amethyst is expected to go to (e.g.) /usr/local/bin, while the rest
# goes to products/. Compile and install it manually beforehand.
#
# add_subdirectory (amethyst)

add_subdirectory (doomsdayscript)
add_subdirectory (md2tool)
add_subdirectory (savegametool)
if (DENG_ENABLE_GUI)
    add_subdirectory (shell)
endif ()
if (UNIX)
    add_subdirectory (shell-text) # requires ncurses
endif ()
add_subdirectory (texc)
add_subdirectory (wadtool)

=== doomsday/apps/client/CMakeLists.txt ===
# The Doomsday Engine Project -- Client
# Copyright (c) 2012-2017 Jaakko Keränen <jaakko.keranen@iki.fi>
# Copyright (c) 2012-2014 Daniel Swanson <danij@dengine.net>

cmake_minimum_required (VERSION 3.1)
project (DENG_CLIENT)
set (DENG_ENABLE_PK3S ON)
include (../../cmake/Config.cmake)

# Dependencies --------------------------------------------------------------------------

find_package (DengAppfw)
find_package (DengDoomsday)
find_package (Amethyst QUIET)
find_package (SDL2)
if (WIN32)
    find_package (DirectX)
endif ()

# Sources and includes ------------------------------------------------------------------

include_directories (include ${DENG_API_DIR})

add_definitions (-D__DOOMSDAY__=1 -D__CLIENT__=1)

file (GLOB         API_HEADERS ../api/*.h)
file (GLOB_RECURSE HEADERS     include/[A-Za-z]*)
file (GLOB         SOURCES     src/*.cpp src/*.c)

deng_merge_sources (audio         src/audio/*.cpp)
deng_merge_sources (audio_base    src/audio/base/*.cpp)
deng_merge_sources (client        src/client/*.cpp)
deng_merge_sources (misc          src/misc/*.cpp)
deng_merge_sources (network       src/network/*.cpp)
deng_merge_sources (network_base  src/network/base/*.cpp)
deng_merge_sources (render        src/render/*.cpp)
deng_merge_sources (render_fx     src/render/fx/*.cpp)
deng_merge_sources (resource      src/resource/*.cpp)
deng_merge_sources (resource_base src/resource/base/*.cpp)
deng_merge_sources (ui            src/ui/*.cpp)
deng_merge_sources (ui_dialogs    src/ui/dialogs/*.cpp)
deng_merge_sources (ui_editors    src/ui/editors/*.cpp)
deng_merge_sources (ui_home       src/ui/home/*.cpp)
deng_merge_sources (ui_infine     src/ui/infine/*.cpp)
deng_merge_sources (ui_widgets    src/ui/widgets/*.cpp)
if (NOT IOS)
    add_definitions (-DDENG_HAVE_UPDATER)
    deng_merge_sources (updater   src/updater/*.cpp)
endif ()
deng_merge_sources (world         src/world/*.cpp)
deng_merge_sources (world_base    src/world/base/*.cpp)
deng_merge_sources (world_bsp     src/world/bsp/*.cpp)

deng_glob_sources (SOURCES src/gl/*.cpp) # Can't merge due to GL deferred calls mechanism.

if (APPLE)
    include_directories (include/macx)
    deng_glob_sources (HEADERS include/macx/*.h)
    deng_glob_sources (SOURCES src/macx/*.mm)
elseif (WIN32)
    include_directories (include/windows)
    deng_glob_sources (SOURCES src/windows/*.cpp)
    list (APPEND SOURCES res/windows/doomsday.rc)
endif ()
if (UNIX)
    include_directories (include/unix)
    deng_merge_sources (unix src/unix/*.cpp)
endif ()

# Documentation sources.
if (AMETHYST_FOUND)
    if (APPLE)
        set (readme "${CMAKE_CURRENT_BINARY_DIR}/Read Me.html")
        deng_add_amedoc (HTML "${readme}" ${DENG_SOURCE_DIR}/doc/readme readme.ame)
        install (FILES ${readme} DESTINATION .)
        list (APPEND SOURCES ${readme})
    else ()
        set (readme "${CMAKE_CURRENT_BINARY_DIR}/readme.html")
        deng_add_amedoc (HTML ${readme} ${DENG_SOURCE_DIR}/doc/readme readme.ame)
        list (APPEND SOURCES ${readme})
        if (WIN32)
            # WIX generator requires setting this manually.
            set_property (INSTALL "${DENG_INSTALL_DOC_DIR}/readme.html"
                PROPERTY CPACK_START_MENU_SHORTCUTS "Read Me"
            )
        endif ()
    endif ()
    # Manual page.
    if (UNIX)
        set (MAN_PAGE ${CMAKE_CURRENT_BINARY_DIR}/doomsday.6)
        deng_add_amedoc (MAN ${MAN_PAGE} ${DENG_SOURCE_DIR}/doc/readme readme.ame)
        list (APPEND SOURCES ${MAN_PAGE})
    endif ()
endif ()

deng_filter_platform_sources (src ${SOURCES} ${HEADERS} ${API_HEADERS})

deng_add_package (net.dengine.client)

if (IOS)
    set (MACX_RESOURCES
        doomsday.pk3
    )

    file (WRITE ${CMAKE_CURRENT_BINARY_DIR}/qt_plugin_import.cpp
        "#include <QtPlugin>
        Q_IMPORT_PLUGIN(QIOSIntegrationPlugin)
        Q_IMPORT_PLUGIN(QGifPlugin)
        Q_IMPORT_PLUGIN(QICNSPlugin)
        Q_IMPORT_PLUGIN(QJpegPlugin)
        Q_IMPORT_PLUGIN(QTgaPlugin)")
    list (APPEND src ${CMAKE_CURRENT_BINARY_DIR}/qt_plugin_import.cpp)

    file (GLOB IOS_ICON_FILES res/ios/AppIcon*.png)

    list (APPEND src
        res/ios/LaunchScreen.xib
        ${IOS_ICON_FILES}
    )
endif ()

# OS X: Packages and other resources to bundle with the application.
if (APPLE AND NOT IOS)
    set (MACX_RESOURCES
        res/macx/deng.icns
        res/macx/English.lproj
        doomsday.pk3
    )
endif ()

# Windows: Use Qt resources.
if (WIN32)
    qt5_add_resources (RCC_SOURCES res/windows/client.qrc)
    list (APPEND src ${RCC_SOURCES})
endif ()

deng_add_application (client ${src} EXTRA_RESOURCES ${MACX_RESOURCES})

# There's some old code here so relax the warnings a bit.
relaxed_warnings (client)

# Libraries -----------------------------------------------------------------------------

if (IOS)
    link_framework (client PUBLIC CoreFoundation)
    link_framework (client PUBLIC QuartzCore)
    link_framework (client PUBLIC CoreGraphics)
    link_framework (client PUBLIC CoreText)
    link_framework (client PUBLIC Foundation)
    link_framework (client PUBLIC ImageIO)
    link_framework (client PUBLIC MobileCoreServices)
    link_framework (client PUBLIC Security)
    link_framework (client PUBLIC UIKit)

    # Static Qt libraries.
    target_link_libraries (client PUBLIC
        debug ${QT_LIBS}/libqtlibpng_debug.a
        debug ${QT_LIBS}/libqtharfbuzz_debug.a
        debug ${QT_LIBS}/libqtfreetype_debug.a
        debug ${QT_LIBS}/libqtpcre_debug.a
        debug ${QT_LIBS}/libQt5FontDatabaseSupport_debug.a
        debug ${QT_LIBS}/libQt5GraphicsSupport_debug.a
        debug ${QT_LIBS}/libQt5ClipboardSupport_debug.a
        debug ${QT_PLUGINS}/platforms/libqios_debug.a
        debug ${QT_PLUGINS}/imageformats/libqgif_debug.a
        debug ${QT_PLUGINS}/imageformats/libqicns_debug.a
        debug ${QT_PLUGINS}/imageformats/libqtga_debug.a
        debug ${QT_PLUGINS}/imageformats/libqjpeg_debug.a

        optimized ${QT_LIBS}/libqtlibpng.a
        optimized ${QT_LIBS}/libqtharfbuzz.a
        optimized ${QT_LIBS}/libqtfreetype.a
        optimized ${QT_LIBS}/libqtpcre.a
        optimized ${QT_LIBS}/libQt5FontDatabaseSupport.a
        optimized ${QT_LIBS}/libQt5GraphicsSupport.a
        optimized ${QT_LIBS}/libQt5ClipboardSupport.a
        optimized ${QT_PLUGINS}/platforms/libqios.a
        optimized ${QT_PLUGINS}/imageformats/libqgif.a
        optimized ${QT_PLUGINS}/imageformats/libqicns.a
        optimized ${QT_PLUGINS}/imageformats/libqtga.a
        optimized ${QT_PLUGINS}/imageformats/libqjpeg.a

        importdeh
        importidtech1
        importudmf
        doom
        doom64
        heretic
        hexen
        audio_fmod
    )
elseif (APPLE)
    link_framework (client PUBLIC Cocoa)
    if (DENG_HAVE_QTKIT)
        link_framework (client PUBLIC QTKit) # MusicPlayer
    endif ()
endif ()
if (TARGET SDL2)
    target_link_libraries (client PUBLIC SDL2)
endif ()
if (TARGET SDL2_mixer)
    target_link_libraries (client PUBLIC SDL2_mixer)
endif ()
if (TARGET DirectX)
    target_link_libraries (client PUBLIC DirectX)
endif ()
if (CMAKE_SYSTEM_NAME MATCHES "BSD")
    target_link_libraries (client PUBLIC execinfo)
endif()

target_link_libraries (client PUBLIC Deng::libappfw Deng::libdoomsday)

# Deployment ----------------------------------------------------------------------------

if (WIN32 OR APPLE)
    set (MACOSX_BUNDLE_BUNDLE_EXECUTABLE "Doomsday")
    set (MACOSX_BUNDLE_BUNDLE_NAME "net.dengine.doomsday")
    set (MACOSX_BUNDLE_ICON_FILE "deng.icns")
    set_target_properties (client PROPERTIES
        OUTPUT_NAME "Doomsday"
        MACOSX_BUNDLE_INFO_PLIST MacOSXBundleInfo.plist.in
    )
else ()
    set_property (TARGET client PROPERTY OUTPUT_NAME "doomsday")
endif ()

if (UNIX_LINUX)
    configure_file (res/linux/net.dengine.Doomsday.desktop.in
        net.dengine.Doomsday.desktop)
    install (PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/net.dengine.Doomsday.desktop
        DESTINATION share/applications)
    install (FILES res/linux/deng-logo-256.png
        DESTINATION ${DENG_INSTALL_DATA_DIR})
    install (FILES res/linux/deng-logo-256.png
        DESTINATION share/icons/hicolor/256x256/apps
        RENAME net.dengine.Doomsday.png)
    install (FILES res/linux/net.dengine.Doomsday.metainfo.xml
        DESTINATION share/metainfo
        RENAME net.dengine.Doomsday.appdata.xml)
endif ()

if (WIN32)
    # WIX generator requires setting Start Menu shortcut manually.
    set_property (INSTALL "bin/$<TARGET_FILE_NAME:client>"
        PROPERTY CPACK_START_MENU_SHORTCUTS "Doomsday Engine"
    )
    # Also include OpenSSL support.
    if (OPENSSL_DIR)
        find_file (OPENSSL_LIBEAY libeay32.dll
            PATHS ${OPENSSL_DIR}
            PATH_SUFFIXES ${DENG_ARCH})
        find_file (OPENSSL_SSLEAY ssleay32.dll
            PATHS ${OPENSSL_DIR}
            PATH_SUFFIXES ${DENG_ARCH})
        if (NOT OPENSSL_LIBEAY OR NOT OPENSSL_SSLEAY)
            message (FATAL_ERROR "Could not find OpenSSL libraries (libeay32.dll, ssleay32.dll)")
        endif ()
        deng_install_library (${OPENSSL_LIBEAY})
        deng_install_library (${OPENSSL_SSLEAY})
    endif ()
endif ()

if (IOS)
    set_target_properties (client PROPERTIES
        LINK_FLAGS "-Wl,-e,_qt_main_wrapper"
        RESOURCE "res/ios/LaunchScreen.xib;${IOS_ICON_FILES}"
        MACOSX_BUNDLE_INFO_PLIST iOSBundleInfo.plist.in
        XCODE_ATTRIBUTE_TARGETED_DEVICE_FAMILY "1,2"
        XCODE_ATTRIBUTE_COMBINE_HIDPI_IMAGES NO
    )
endif ()

if (APPLE AND NOT IOS)
    deng_install_bundle_deps (client
        Deng::libcore Deng::libshell Deng::libgui Deng::libappfw
        Deng::liblegacy Deng::libdoomsday Deng::libgamefw
        SDL2 SDL2_mixer
    )

    # Plugins are bundled inside the client app. We'll run macdeployqt on the
    # installed app before the plugins are there so it won't do unnecessary
    # work on them -- plugins are already self-contained.
    get_property (outName TARGET client PROPERTY OUTPUT_NAME)
    set (stageDir "${DENG_BUILD_STAGING_DIR}/DengPlugins")
    if (IOS)
        set (destDir "${outName}.app/PlugIns")
    else ()
        set (destDir "${outName}.app/Contents/PlugIns/Doomsday")
    endif ()
    install (CODE "execute_process (COMMAND ${CMAKE_COMMAND} -E remove_directory
        \"\${CMAKE_INSTALL_PREFIX}/${destDir}\")")
    deng_install_deployqt (client)
    install (CODE "execute_process (COMMAND ${CMAKE_COMMAND} -E copy_directory \"${stageDir}\"
        \"\${CMAKE_INSTALL_PREFIX}/${destDir}\")")
else ()
    deng_install_deployqt (client)
endif ()

if (VC_REDIST_LIBS_DEBUG)
    install (PROGRAMS ${VC_REDIST_LIBS_DEBUG}
        DESTINATION ${DENG_INSTALL_LIB_DIR}
        CONFIGURATIONS Debug
        COMPONENT libs
    )
endif ()

if (VC_REDIST_LIBS)
    install (PROGRAMS ${VC_REDIST_LIBS}
        DESTINATION ${DENG_INSTALL_LIB_DIR}
        CONFIGURATIONS Release
        COMPONENT libs
    )
endif ()

if (MSVC)
    # Bless the build products folder for running the executables.
    # We have to write a batch file that adds the correct Qt to the path,
    # or otherwise windeployqt cannot find the correct libraries to deploy.
    get_filename_component (QT_BINS ${WINDEPLOYQT_COMMAND} DIRECTORY)
    file (TO_NATIVE_PATH ${QT_BINS} qtBins)
    file (TO_NATIVE_PATH ${WINDEPLOYQT_COMMAND} winDepCmd)
    set (fn ${CMAKE_BINARY_DIR}/deployqt.bat)
    file (WRITE ${fn}
        "set PATH=\"${qtBins}\";%PATH%
        \"${winDepCmd}\" -opengl --no-compiler-runtime --no-translations \"${DENG_VS_STAGING_DIR}/%1/bin/doomsday.exe\""
    )
    set (_intDir ${CMAKE_CFG_INTDIR})
    if (_intDir STREQUAL ".")
        set (_intDir ${CMAKE_BUILD_TYPE})
    endif ()
    add_custom_command (TARGET client POST_BUILD COMMAND ${fn} ${_intDir})
endif ()

deng_cotire (client include/precompiled.h)

=== doomsday/doc/output/Makefile ===
readme_sources := $(wildcard ../readme/*.ame)
readme_main := ../readme/readme.ame

shell_sources := $(wildcard ../shell-text/*.ame)
shell_main := ../shell-text/shell-text.ame

sv_sources := $(wildcard ../server/*.ame)
sv_main := ../server/server.ame

.PHONY: wiki

all: wiki

wiki:
	python /Users/jaakko/Dropbox/Scripts/readme_to_wiki.py

=== doomsday/sdk/libappfw/CMakeLists.txt ===
# Doomsday Engine -- libappfw

cmake_minimum_required (VERSION 3.1)
project (DENG_LIBAPPFW)
include (../../cmake/Config.cmake)

# Dependencies.
find_package (DengCore)
find_package (DengGui)
find_package (DengShell)
find_package (OculusVR QUIET)

# Definitions.
add_definitions (-D__LIBAPPFW__=1)

# Source and header files.
file (GLOB_RECURSE HEADERS include/de/*)
file (GLOB SOURCES src/*.h)

deng_merge_sources (libappfw src/*.cpp)
deng_merge_sources (dialogs  src/dialogs/*.cpp)
deng_merge_sources (vr       src/vr/*.cpp)
deng_merge_sources (widgets  src/widgets/*.cpp)

deng_add_library (libappfw ${SOURCES} ${HEADERS})

target_link_libraries (libappfw
    PUBLIC Deng::libcore Deng::libgui Deng::libshell
)
deng_target_link_qt (libappfw PUBLIC Widgets OpenGL)
if (TARGET LibOVR)
    target_link_libraries (libappfw PRIVATE LibOVR)
endif ()
if (WIN32)
    # Direct2D is used for DPI information.
    target_link_libraries (libappfw PRIVATE d2d1.lib)
endif ()

deng_deploy_library (libappfw DengAppfw)

deng_cotire (libappfw src/precompiled.h)

=== doomsday/sdk/libgui/CMakeLists.txt ===
--- 
+++ 
@@ -2,8 +2,6 @@
 
 cmake_minimum_required (VERSION 3.1)
 project (DENG_LIBGUI)
-
-option (DENG_ASSIMP_EMBEDDED "Use the Assimp from 'external/assimp' instead of system libraries" YES)
 
 set (CMAKE_INSTALL_DEFAULT_COMPONENT_NAME)

=== doomsday/sdk/liblegacy/CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,8 @@
 # Source and header files.
 file (GLOB_RECURSE HEADERS include/de/*)
 file (GLOB_RECURSE SOURCES src/*.cpp src/*.c)
-#file (GLOB_RECURSE C_SOURCES src/*.c)
+
+set_property (SOURCE include/de/str.hh PROPERTY SKIP_AUTOMOC ON) # see CMP0100
 
 include_directories (include include/de)

=== doomsday/sdk/libshell/CMakeLists.txt ===
# Doomsday Engine -- libshell

cmake_minimum_required (VERSION 3.1)
project (DENG_LIBSHELL)
include (../../cmake/Config.cmake)

# Dependencies.
find_package (DengCore)

# Definitions.
add_definitions (-D__LIBSHELL__=1)

# Source and header files.
file (GLOB_RECURSE HEADERS include/de/shell/*)
file (GLOB SOURCES src/*.h)

deng_merge_sources (libshell src/*.cpp)

deng_add_library (libshell ${SOURCES} ${HEADERS})
target_link_libraries (libshell PUBLIC Deng::libcore)

deng_deploy_library (libshell DengShell)

deng_cotire (libshell src/precompiled.h)

=== doomsday/tests/test_commandline/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1)
project (DENG_TEST_COMMANDLINE)
include (../TestConfig.cmake)

deng_test (test_commandline main.cpp)

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Michael Gilbert <mgilbert@debian.org>
 Build-Depends:
  cmake,
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  python3:any,
  qtbase5-dev,
  zlib1g-dev,
@@ -21,11 +21,11 @@
  libgl1-mesa-dev | libgl-dev,
  libglu1-mesa-dev | libglu-dev,
  libminizip-dev,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://www.dengine.net
-Vcs-Git: https://salsa.debian.org/games-team/doomsday.git
-Vcs-Browser: https://salsa.debian.org/games-team/doomsday
+Vcs-Git: https://salsa.debian.org/games-team/deng.git
+Vcs-Browser: https://salsa.debian.org/games-team/deng
 
 Package: doomsday
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

export DEB_LDFLAGS_MAINT_APPEND=

export QT_SELECT := 5

# For SOURCE_DATE_EPOCH and DEB_VERSION
include /usr/share/dpkg/default.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	        -DDENG_ASSIMP_EMBEDDED:BOOL=OFF \
	        -DDENG_BUILD=$(DEB_VERSION) \
	        -DCMAKE_INSTALL_BINDIR=games \
	        -DCMAKE_POLICY_VERSION_MINIMUM=3.5

=== debian/watch ===
version=4
opts="repack,compression=xz,repacksuffix=+ds1,dversionmangle=auto" \
 https://files.dengine.net/archive/ doomsday-([\d.]+)@ARCHIVE_EXT@ debian uupdate
